function scissorsSelected(id, c) {
	jQuery('#scissorsX-'+id).val(c.x);
	jQuery('#scissorsY-'+id).val(c.y);
	jQuery('#scissorsW-'+id).val(c.w);
	jQuery('#scissorsH-'+id).val(c.h);
	var str = (c.w <= 0 || c.h <= 0) ? '' : '('+c.x+', '+c.y+') - ('+c.x2+', '+c.y2+'), [' + c.w + ' x ' + c.h + ']';
	jQuery('#scissorsSel-'+id).html(str);
}

function scissorsAspectRatio(id) {
	return jQuery('#scissorsLockBox-'+id)[0].checked ? (jQuery('#scissorsLockX-'+id).val() / jQuery('#scissorsLockY-'+id).val()) : 0;
}

function scissorsAspectChange(id) {
	jQuery('#scissorsImg-'+id).Jcrop({ aspectRatio: scissorsAspectRatio(id) });
}

function scissorsShowCrop(id, imgSrc) {
	jQuery('#scissorsShowBtn-'+id).hide();
	var img = jQuery('#scissorsImg-'+id);
	if(img[0].src == '') {
		img.attr('src', imgSrc + '?rand=' + Math.floor(Math.random() * 1000000)); // force a reload of the image by appending a random query string to the url
		img.Jcrop({
			boxWidth: 468,
			aspectRatio: scissorsAspectRatio(id),
			onChange: function(c) { return scissorsSelected(id, c); },
			onSelect: function(c) { return scissorsSelected(id, c); }
		});
	}
	jQuery('#scissorsCropPane-'+id).show();
	return false;
}

function scissorsAbortCrop(id) {
	jQuery('#scissorsCropPane-'+id).hide();
	jQuery('#scissorsShowBtn-'+id).show();
	return false;
}

function scissorsResetCrop(id) {
	jQuery('#scissorsImgHost-'+id).html("<img id='scissorsImg-" + id + "' />");
	jQuery('#scissorsSel-'+id).html('');
	jQuery('#scissorsW-'+id).val('-1');
}

function scissorsPostQuery(id, scriptUrl, dataStr) {
	$.ajax({
		type: 'POST', url: scriptUrl, data: dataStr,
		success: function(msg) {
			var m = msg.split(';');
			if(m.length == 2) {
				if(m[0].indexOf('large') >= 0) {
					// reload the large image on next crop and update the displayed size
					scissorsResetCrop(id);
					jQuery('#scissorsSize-'+id).html(m[1]);
				}
				if(m[0].indexOf('thumbnail') >= 0) {
					// force a reload of the thumbnail by appending a random query string to the url
					var thumbnail = jQuery('#media-item-'+id).find('.thumbnail');
					var imgSrc = thumbnail.attr('src');
					var randIndex = imgSrc.indexOf('?rand=');
					if(randIndex >= 0) imgSrc = imgSrc.substr(0, randIndex); // strip existing rand
					imgSrc += '?rand=' + Math.floor(Math.random() * 1000000);
					thumbnail.attr('src', imgSrc);
				}
			} else {
				alert(msg);
			}
		},
		complete: function(req) {
			jQuery('#scissorsWaitFld-'+id).hide();
			jQuery('#scissorsShowBtn-'+id).show();
		}
	});
}

function scissorsCrop(id, nonce, scriptUrl) {
	var w = parseInt(jQuery('#scissorsW-'+id).val()), h = parseInt(jQuery('#scissorsH-'+id).val());
	if (w > 0 && h > 0) {
		jQuery('#scissorsCropPane-'+id).hide();
		jQuery('#scissorsWaitFld-'+id).show();
	
		var x = parseInt(jQuery('#scissorsX-'+id).val()), y = parseInt(jQuery('#scissorsY-'+id).val());
		var dataStr = 'action=scissorsCrop&_wpnonce=' + nonce + '&post_id=' + id + '&x=' + x + '&y=' + y + '&w=' + w + '&h=' + h;
		dataStr += '&target=' + jQuery('#scissorsCropTarget-'+id).val();
		scissorsPostQuery(id, scriptUrl, dataStr);
	}
	return false;
}

function scissorsShowResize(id) {
	jQuery('#scissorsShowBtn-'+id).hide();
	jQuery('#scissorsResizePane-'+id).show();
	return false;
}

function scissorsAbortResize(id) {
	jQuery('#scissorsResizePane-'+id).hide();
	jQuery('#scissorsShowBtn-'+id).show();
	return false;
}

function scissorsResize(id, nonce, scriptUrl) {
	var side = parseInt(jQuery('#scissorsSide-'+id).val());
	if (side > 0) {
		jQuery('#scissorsResizePane-'+id).hide();
		jQuery('#scissorsWaitFld-'+id).show();
	
		var mode = jQuery('#scissorsMode-'+id).val();
		var dataStr = 'action=scissorsResize&_wpnonce=' + nonce + '&post_id=' + id + '&side=' + side + '&mode=' + mode;
		scissorsPostQuery(id, scriptUrl, dataStr);
	}
	return false;
}
